##########################################################################
#
#  createDatas.r
#
# load all data files
# do a first merging and preprocessing
#
##########################################################################



loadData <- function() {
  #distance xp - outside data
  inp1 <- scan("distance_outside_1_20.txt", list(time=0,sendId=0,transId=0,radioLevel=0,cnt=0,rssi=0,lqi=0),dec = ",")
  inp2 <- scan("distance_outside_21_40.txt", list(time=0,sendId=0,transId=0,radioLevel=0,cnt=0,rssi=0,lqi=0),dec = ",")

  inpOut <<- list(time=c(inp1$time,inp2$time),
    sendId=c(inp1$sendId,inp2$sendId),
    transId=c(inp1$transId,inp2$transId),
    radioLevel=c(inp1$radioLevel,inp2$radioLevel),
    cnt=c(inp1$cnt,inp2$cnt),
    rssi=c(inp1$rssi,inp2$rssi),
    lqi=c(inp1$lqi,inp2$lqi)
  )

  #temps en heures  partir de 0
  inpOut$time <<- (inpOut$time - min(inpOut$time))
  
  #rssi harmonisation
  inpOut$rssi <<- inpOut$rssi - 80


  #distance xp - inside data
  inp3 <- scan("distance_inside_1_20.txt",list(time=0,sendId=0,transId=0,radioLevel=0,cnt=0,rssi=0,lqi=0),dec = ",")
  inp4 <- scan("distance_inside_21_40.txt",list(time=0,sendId=0,transId=0,radioLevel=0,cnt=0,rssi=0,lqi=0),dec = ",")
  inp5 <- scan("distance_inside_41_59.txt",list(time=0,sendId=0,transId=0,radioLevel=0,cnt=0,rssi=0,lqi=0),dec = ",")

  inpIn <<- list(time=c(inp3$time,inp4$time,inp5$time),
    sendId=c(inp3$sendId,inp4$sendId,inp5$sendId),
    transId=c(inp3$transId,inp4$transId,inp5$transId),
    radioLevel=c(inp3$radioLevel,inp4$radioLevel,inp5$radioLevel),
    cnt=c(inp3$cnt,inp4$cnt,inp5$cnt),
    rssi=c(inp3$rssi,inp4$rssi,inp5$rssi),
    lqi=c(inp3$lqi,inp4$lqi,inp5$lqi)
  )

  #temps en heures  partir de 0
  inpIn$time <<- (inpIn$time - min(inpIn$time))

  #rssi harmonisation
  inpIn$rssi <<- inpIn$rssi - 80



  #biblio1 neighbors datas
  bib1n1 <- scan("bib1n1.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")
  bib1n2 <- scan("bib1n2.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")
  #bib1n3 <- read.table("bib1n3.txt")

  bib1 <<-list(time=c(bib1n1$time,bib1n2$time),#time=c(bib1n1$time,bib1n2$time,bib1n3$V1),
    idx=c(bib1n1$idx,bib1n2$idx), #idx=c(bib1n1$idx,bib1n2$idx,bib1n3$V2),
    #seqno=c(bib1n1$seqno,bib1n2$seqno,as.numeric(bib1n3$V3)+1000),      #we don't car about this it cause troubles
    src=c(bib1n1$src,bib1n2$src), #src=c(bib1n1$src,bib1n2$src,bib1n3$V4),
    pongsrc=c(bib1n1$pongsrc,bib1n2$pongsrc),#pongsrc=c(bib1n1$pongsrc,bib1n2$pongsrc,bib1n3$V5),
    lqi=c(bib1n1$lqi,bib1n2$lqi),#lqi=c(bib1n1$lqi,bib1n2$lqi,bib1n3$V6),
    rssi=c(bib1n1$rssi,bib1n2$rssi)#rssi=c(bib1n1$rssi,bib1n2$rssi,bib1n3$V7)
  )

  #correction because of an error in the java logger program
  j <- bib1$lqi > 128
  bib1$lqi[j] <<- bib1$lqi[j] - 128 - 32
  bib1$lqi[!j] <<- bib1$lqi[!j] + 128 - 32

  #correction because of an error in the java logger program
  bib1$rssi <<- - bib1$rssi + 270 - 45
  #j <- bib1$rssi > 128
  #bib1$rssi[j] <<- - (256 - bib1$rssi[j])

  
  

  #temps en heures  partir de 0
  bib1$time <<- (bib1$time - min(bib1$time)) / 3600000

  #biblio1 sensing datas
  #bib1r1 <- scan("bib1r1.txt", list(time=0,nodeid=0,seqno=0,tempint=0,volt=0,hum=0,temp=0,par=0,tsr=0),dec = ",")
  #bib1r2 <- scan("bib1r2.txt", list(time=0,nodeid=0,seqno=0,tempint=0,volt=0,hum=0,temp=0,par=0,tsr=0),dec = ",")
  #bib1r3 <- read.table("bib1r3.txt")

  #bib1datas <<-list(time=c(bib1r1$time,bib1r2$time,bib1r3$V1),
   # nodeid=c(bib1r1$nodeid,bib1r2$nodeid,bib1r3$V2),
    #seqno=c(bib1r1$seqno,bib1r2$seqno,as.numeric(bib1r3$V3)+1000),      #we don't car about this it cause troubles
  #  tempint=c(bib1r1$tempint,bib1r2$tempint,bib1r3$V4),
 #   volt=c(bib1r1$volt,bib1r2$volt,bib1r3$V5),
 #   hum=c(bib1r1$hum,bib1r2$hum,bib1r3$V6),
 #   temp=c(bib1r1$temp,bib1r2$temp,bib1r3$V7),
  #  par=c(bib1r1$par,bib1r2$par,bib1r3$V8),
  #  tsr=c(bib1r1$tsr,bib1r2$tsr,bib1r3$V9)
 # )
  
  #temps en heures  partir de 0
#  bib1datas$time <<- (bib1datas$time - min(bib1datas$time)) / 3600000




  #biblio2
  bib2 <<- scan("bib2.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")
   #temps en heures  partir de 0
   bib2$time <<- (bib2$time - min(bib2$time)) / 3600000

  #serres neighbors data
  ser1 <- scan("serresn1.txt", list(time=0,idx=0,seqno=0,from=0,to=0,lqi=0,rssi=0),dec = ",")
  ser2 <- scan("serresn2.txt", list(time=0,idx=0,seqno=0,from=0,to=0,lqi=0,rssi=0),dec = ",")
  ser3 <- read.table("serresn3.txt")
  ser4 <- read.table("serresn4.txt")


 # VV3 <- numeric()
#  VV4 <- numeric()

 # #correct some problems with seqno > 999                               #we don't car about this it cause troubles
#  for (i in 1:length(ser3$V3)) {
#    spl <- strsplit(as.character(ser3$V3[i]),"")[[1]]
#    if(length(spl) == 2) {
#      VV3[i] <- 1000 + as.numeric(spl[2])
#    } else {
#      VV3[i] <- ser3$V3[i]
#    }
#  }
#
#  for (i in 1:length(ser4$V3)) {
#    spl <- strsplit(as.character(ser4$V3[i]),"")[[1]]
#    if(length(spl) == 2) {
#      VV4[i] <- 1000 + as.numeric(spl[2])
#    } else {
#      VV4[i] <- ser4$V3[i]
#    }
#  }

  ser <<- list(time=c(ser1$time,ser2$time,ser3$V1,ser4$V1),
    idx=c(ser1$idx,ser2$idx,ser3$V1,ser4$V2),
    #seqno=c(ser1$seqno,ser2$seqno,VV3,VV4),                               #we don't car about this it cause troubles
    src=c(ser1$from,ser2$from,ser3$V4,ser4$V4),
    pongsrc=c(ser1$to,ser2$to,ser3$V5,ser4$V5),
    lqi=c(ser1$lqi,ser2$lqi,ser3$V6,ser4$V6),
    rssi=c(ser1$rssi,ser2$rssi,ser3$V7,ser4$V7)
  )

  #correct the problem in java logger program
  j <- ser$lqi > 128
  ser$lqi[j] <<- ser$lqi[j] - 128 - 32
  ser$lqi[!j] <<- ser$lqi[!j] + 128 - 32

   #temps en heures  partir de 0
  ser$time <<- (ser$time - min(ser$time)) / 3600000


  #serres sensing data
  ser1d <- read.table("serresr1.txt")
  ser2d <- read.table("serresr2.txt")
  ser3d <- read.table("serresr3.txt")
  ser4d <- read.table("serresr4.txt")

  serdatas <<- list(time=c(ser1d$V1,ser2d$V1,ser3d$V1,ser4d$V1),
    nodeid=c(ser1d$V2,ser2d$V2,ser3d$V2,ser4d$V2),
    #seqno=c(bib1r1$seqno,bib1r2$seqno,as.numeric(bib1r3$V3)+1000),    #we don't car about this it cause troubles
    tempint=c(ser1d$V4,ser2d$V4,ser3d$V4,ser4d$V4),
    volt=c(ser1d$V5,ser2d$V5,ser3d$V5,ser4d$V5),
    hum=c(ser1d$V6,ser2d$V6,ser3d$V6,ser4d$V6),
    temp=c(ser1d$V7,ser2d$V7,ser3d$V7,ser4d$V7),
    par=c(ser1d$V8,ser2d$V8,ser3d$V8,ser4d$V8),
    tsr=c(ser1d$V9,ser2d$V9,ser3d$V9,ser4d$V9)
  )

   #temps en heures  partir de 0
  serdatas$time <<- (serdatas$time - min(serdatas$time)) / 3600000


}

distanceBib1 <- function(i,j) {
  sqrt((real.x[i-1]-real.x[j-1])^2+(real.y[i-1]-real.y[j-1])^2)
}


#will be global variables
bib1nodes <- numeric()
bib1nodes <<- c(2:5,7:20)
bib1nodesc <- c(1:4,6:19)
inpIn <- list()
inpOut <- list()
bib1 <- list()
bib1datas <- list()
bib2 <- list()
ser <- list()
serdatas <-list()

real.x <- numeric()
real.y <- numeric()
real.x[1] <- 0
real.y[1] <- 0
real.x[2] <- 0
real.y[2] <- 0.9
real.x[3] <- 0
real.y[3] <- 2.05
real.x[4] <- 0
real.y[4] <- 2.95

real.x[5] <- 1.5
real.y[5] <- 0
real.x[6] <- 1.5
real.y[6] <- 0.9
real.x[7] <- 1.5
real.y[7] <- 2.05
real.x[8] <- 1.5
real.y[8] <- 3

real.x[9] <- 3.3
real.y[9] <- 0
real.x[10] <- 3.3
real.y[10] <- 0.9
real.x[11] <- 3.3
real.y[11] <- 2.05
real.x[12] <- 3.3
real.y[12] <- 3

real.x[13] <- 4.8
real.y[13] <- 0
real.x[14] <- 4.8
real.y[14] <- 0.9
real.x[15] <- 4.8
real.y[15] <- 2.05
real.x[16] <- 4.8
real.y[16] <- 3

real.x[17] <- 6.6
real.y[17] <- 0
real.x[18] <- 6.6
real.y[18] <- 0.9
real.x[19] <- 6.6
real.y[19] <- 2.05

real.x <- real.x - mean(real.x)
real.y <- real.y - mean(real.y)

LQI_MIN <- 50
LQI_MAX <- 110
RSSI_MIN <- -60
RSSI_MAX <- 40

#call the main function of this script
loadData()
