# LocaliseLAT.R
localiseLAT <- function() {
  nodeCount <- 9
  startNodesCount <- 3
  startNodes <- sample(1:nodeCount,startNodesCount,replace=F)
  toDoNodes <- numeric(nodeCount-startNodesCount)
  cpt <- 1
  
  for (i in 1:nodeCount) {
    if (all(i != startNodes)) {
      toDoNodes[cpt] <- i
      cpt <- cpt+1
    }
  }
  #the order of toDoNodes could be randomized




  #get the real position of anchors
  positions.x <- double(nodeCount)
  positions.y <- double(nodeCount)
  positions.x[startNodes] <- real.x[startNodes]
  positions.y[startNodes] <- real.y[startNodes]

  #for each node not localized
  n <- startNodesCount
  for (i in 1:length(toDoNodes)) {

      A <- matrix(data=,nrow=n-1,ncol=2)
      b <- matrix(data=,nrow=n-1,ncol=1)

      for (j in 1:n-1) {
        A[j,1] <- 2 * (positions.x[startNodes[j]] - positions.x[startNodes[n]])
        A[j,2] <- 2 * (positions.y[startNodes[j]] - positions.y[startNodes[n]])
        b[j] <- (positions.x[startNodes[j]]^2) - (positions.x[startNodes[n]]^2) + (positions.y[startNodes[j]]^2) - (positions.y[startNodes[n]]^2) + (matb[toDoNodes[i],startNodes[n]]^2) - (matb[toDoNodes[i],startNodes[j]]^2)
      }

      startNodes <- rbind(startNodes,toDoNodes[i])
      n <- n+1

      #print(A)
      #print(b)
      #browser()


      try(aaa <- solve(A, b))

      #aaa <-  ginv(t(A) %*% A) %*% t(A) %*%  b

      browser()

      positions.x[toDoNodes[i]] <- aaa[1,1]
      positions.x[toDoNodes[i]] <- aaa[2,1]
  }


  #plot(real.x,real.y,col="red",xlim=c(-5,5),ylim=c(-5,5))
  #text(real.x,real.y,labels=1:19,col="red")

  #points(positiopositns.x,positions.y,col="blue")
  #text(positions.x,positions.y,labels=1:19,col="blue")

  #print(paste("MSE =",mean(sqrt((real.x - positions.x)^2+(real.y-positions.y)^2))))
  cbind(positions.x,positions.y)
}

#loading datas
inp1 <- scan("bib1n1.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")
#preparing datas
ji <- inp1$lqi > 128
inp1$lqi[ji] = 383 - inp1$lqi[ji]
inp1$lqi[!ji] = 128 - inp1$lqi[!ji]

mat <- array(0, dim=c(19,19))
matb <- array(0, dim=c(19,19))
mat2 <- array(0, dim=c(19,19))

lqis <- numeric()

len = 10000 #length(inp1$src)

for (i in 2:19) {
  for (j in (i+1):20) {
      x <- 0
      for (k in 1:len) {
        if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
          lqis[x] <- inp1$lqi[k]
          x<-x+1
        }
      }
#        print(lqis)
      mat[j-1,i-1] <- (-10.50084 + (mean(lqis) * 0.09973)) #to get dissimilarities
      mat[i-1,j-1] <- mat[j-1,i-1]
      matb[j-1,i-1] <- (-11.04994 + (mean(lqis) * 0.10467)) #to get dissimilarities
      matb[i-1,j-1] <- matb[j-1,i-1]
  }


}









R <- 1000
mse <- double(R)
keep.x <- list()
keep.y <- list()
#cpt <- 1
seq <-  1:19
min <- 100000
for (i in 1:R) {
  tmp <- localiseLAT()
  mse[i] <- sqrt(mean((real.x - tmp[seq])^2+(real.y-tmp[19+seq])^2))
  if ( mse[i] < min) {
    keep.x <- tmp[seq]
    keep.y <- tmp[19+seq]
}
  print(i)
}

#plot (1:R,mse,ylim=c(0,20))
x11()
plot (1:R,mse,ylim=c(0,20),xlab="itrations",ylab="rmse",main="trilateration rmse for different orders")
abline(h=1.5)

x11()
plot(keep.x,keep.y,col="blue")
points(real.x,real.y,col="red")
#plot(real.x,real.y,col="red",xlim=c(-5,5),ylim=c(-5,5))

text(real.x,real.y,labels=1:19,col="red")

#pos.x <- as.double(array(0,dim=c(19,1)))
#pos.y <- as.double(array(0,dim=c(19,1)))
#len <- length(keep.x)
#for (i in 1:len) {
#  for(j in 1:19) {
#    pos.x[j] <- pos.x[j] + keep.x[[i]][j]
#    pos.y[j] <- pos.y[j] + keep.y[[i]][j]
#  }
#  pos.x[j] <- pos.x[j] / len
#  pos.y[j] <- pos.y[j] / len

#}



#points(pos.x,pos.y,col="blue")
#text(pos.x,pos.y,labels=1:19,col="blue")

#points(keep.x,keep.y,col="blue")
text(keep.x,keep.y,labels=1:19,col="blue")

print(paste("MSE mean:",mean(mse)))
print(paste("MSE var:",var(mse)))