# Test of F-statistic for linear dependency
# for lqi - distance linearity
#     rssi - distance linearity
#
# Test of coefficient of determination R
#
# + same tests for a real linear dependency


distance <- function(AnodeId,BnodeId) {
hdist <- 1.5
vdist <- 1


	if (AnodeId == BnodeId) {
		return(0)
	}

	#to begin at 0
	A <- AnodeId - 2
	B <- BnodeId - 2

	dist <- 0


	if (A > B) {
		tmp = B;
		B = A;
		A = tmp;
	} #now A is everytime the node with smaller nodeId

	Acol <- A %/% 4
	Alig <- A %% 4
	Bcol <- B %/% 4
	Blig <- B %% 4

	if (Acol == Bcol) {
		return ((Blig - Alig) * vdist)
	}

	if (Alig == Blig) {
		return ((Bcol - Acol) * hdist)
	}


	#if we arrive here both nodes are neithwarningser same lig neither same col

	if (Alig < Blig) {
		return (sqrt((((Bcol - Acol)*hdist)^2) + (((Blig - Alig)*vdist)^2)) )
	}
	else {
		return (sqrt((((Bcol - Acol)*hdist)^2) + (((Alig - Blig)*vdist)^2)) )
	}
}

inp1 <- scan("bib1n1.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")

j <- inp1$lqi > 128
inp1$lqi[j] = 383 - inp1$lqi[j]
inp1$lqi[!j] = 128 - inp1$lqi[!j]

d.lqi <- numeric()
d.dist <- numeric()
d.rssi <- numeric()

browser()

#traitement donnes
x <- 0
for (i in 1:(length(inp1$lqi))) {
	if (inp1$src[i] > 1 && inp1$pongsrc[i] > 1) {
    if (inp1$seqno[i]%%10 == 0) {
      d.lqi[x] <- inp1$lqi[i]
      d.rssi[x] <- inp1$rssi[i]
      d.dist[x] <- distance(inp1$src[i],inp1$pongsrc[i])
			x<-x+1
    }
	}
}


browser()
d.n <- x


lin.lqi <- lm(d.dist ~ d.lqi)
e.lqi = lin.lqi[[1]][1] + (d.lqi * lin.lqi[[1]][2])

lin.rssi <- lm(d.dist ~ d.rssi)
e.rssi = lin.rssi[[1]][1] + (d.rssi * lin.rssi[[1]][2])

#some calculations
mean.d.dist <-mean(d.dist)
mean.e.dist <- mean(e.lqi)
mean.e.rssi <- mean(e.rssi)


SSmod.lqi <- sum((e.lqi - mean.d.dist)^2)
SSres.lqi <- sum((d.dist - e.lqi)^2)


SSmod.rssi <- sum((e.rssi - mean.d.dist)^2)
SSres.rssi <- sum((d.dist - e.rssi)^2)

#F statistic
F.lqi <- SSmod.lqi / (SSres.lqi / (d.n - 2))
F.rssi <- SSmod.rssi / (SSres.rssi / (d.n - 2))

print(paste("F.lqi",F.lqi))
print(paste("F.rssi",F.rssi))

print("Large values of F statistic provides evidence in favor of a linear dependence between 2 vars")


print("Coefficient of determination R : 0 <= R <= 1")
print(paste("Lqi:",SSmod.lqi/(SSmod.lqi+SSres.lqi)))
print(paste("Lqi:",SSmod.rssi/(SSmod.rssi+SSres.rssi)))

print("#########################")
print("Test with Y = 2 + 3X + w")
print("w ~ N(0,0.3)")
print("#########################")
t.n <- 1000
X <- runif(t.n,0,100)

Y.real<- 2 + (3 * X)
Y.real <- Y.real + rnorm(length(X),mean=0,sd=3)

X.mean <- mean(X)
Y.real.mean <- mean(Y.real)
lin.test <- lm(Y.real ~ X)

Y.est <- lin.test[[1]][1] + (lin.test[[1]][2] * X)



SSmod.test <- sum((Y.est - Y.real.mean)^2)
SSres.test <- sum((Y.real - Y.est)^2)

#F statistic
F.test <- SSmod.test / (SSres.test / (t.n - 2))

print(paste("F.test",F.test))

print("Coefficient of determination R : 0 <= R <= 1")
print(paste("Test:",SSmod.test/(SSmod.test+SSres.test)))

