plotDistRSSI <- function() {
	
  inp1 <- scan("N1.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")
			
	distX <- numeric()
	rssiX <- numeric()
	
  len <- length(inp1$time)	
  x<- 0
  
	for (i in 1:len) {
		if (inp1$src[i] > 1 && inp1$pongsrc[i] > 1) {
		  d <-  (inp1$seqno[i] %% 10)
			if (d == 0) {		
      		rssiX[x] <- inp1$rssi[i]
      		distX[x] <- distance(inp1$src[i],inp1$pongsrc[i])
      		x<-x+1		
    		}
		}
		
	}

	x11()

  lin <- lm(distX ~ rssiX)

	maintitle <- paste("Distance / RSSI")	
  plot(rssiX,distX,main=maintitle,ylab="Distance Between nodes",xlab="RSSI value",pch=3, col = "dark red")
 
  mytext1 <- paste("RSSI mean :",mean(rssiX),"RSSI var :",var(rssiX),"#mesures :",length(distX))
  mytext2 <- paste("#nodes : 19","regline intercept :",lin$coefficients[1],"regline lqiX :",lin$coefficients[2])

  mtext(mytext1, side = 1,line=2)
  mtext(mytext2, side = 1,line=4)  
	
	
	abline( coef = lin$coefficients )
	



	
}


plotDistLQI <- function() {

  inp1 <- scan("N1.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")
  
	j <- inp1$lqi > 128
	inp1$lqi[j] = 383 - inp1$lqi[j]
	inp1$lqi[!j] = 128 - inp1$lqi[!j]
	
	
	lqiX <- numeric()
	distX <- numeric()
	

	x <- 0

	len <- length(inp1$lqi)

	for (i in 1:len) {
		if (inp1$src[i] > 1 && inp1$pongsrc[i] > 1) {
		  d <-  (inp1$seqno[i] %% 10)
			if (d == 0) {
        lqiX[x] <- inp1$lqi[i]
  			distX[x] <- distance(inp1$src[i],inp1$pongsrc[i])
  			x<-x+1
       }	
		}
		
	}

  #browser()
 
#  i <- (distX < 5 && distX > 4)
#  distX <-distX[i] 
#  lqiX <- lqiX[i]
	#filename <- "distance-lqi.ps" 
	#postscript(filename, family = "NimbusSan")
	
	x11()

  lin <- lm(distX ~ lqiX)

	maintitle <- paste("Distance / LQI")	
  plot(lqiX,distX,main=maintitle,ylab="Distance Between nodes",xlab="LQI value",pch=3, col = "dark red")
 
  mytext1 <- paste("LQI mean :",mean(lqiX),"LQI var :",var(lqiX),"#mesures :",length(distX))
  mytext2 <- paste("#nodes : 19","regline intercept :",lin$coefficients[1],"regline lqiX :",lin$coefficients[2])

  mtext(mytext1, side = 1,line=2)
  mtext(mytext2, side = 1,line=4)  
	
	
	abline( coef = lin$coefficients )
	
	#print (lin$coefficients)
  sqrt(var(lin$residuals))
	
	
	#dev.off()



	
}

plotDistRSSILQI <- function() {

	oldwd = getwd()
	setwd("C:\\Documents and Settings\\dwarfy\\My Documents\\MLG\\memoiremlg\\LOCALISATION\\EXPEBIBLIO")

	inp1 <- scan("N1.txt", list(0,0,0,0,0,0,0),dec = ",")
	rssi1 <-inp1[[7]]
	lqi1 <- inp1[[6]]
	fromid1 <- inp1[[4]]
	toid1 <- inp1[[5]]
	

	
	inp2 <- scan("N2.txt", list(0,0,0,0,0,0,0),dec = ",")
	rssi2 <- inp2[[7]]
	lqi2 <- inp2[[6]]
	fromid2 <- inp2[[4]]
	toid2 <- inp2[[5]]
	
	
	setwd(oldwd)

	lqi = c(lqi1,lqi2)
	rssi = c(rssi1,rssi2)
	fromid = c(fromid1,fromid2)
	toid = c(toid1,toid2)
	

	x <- 0
	len <- length(fromid)
	lqiX <- numeric()
	rssiX <- numeric()
	distX <- numeric()
	

	startime <- 0.0

	#times <- times / (3600 * 1024)

	x <- 0

	len <-1000

	for (i in 1:len) {
		if (fromid[i] > 1 && toid[i] > 1) {
			lqiX[x] <- lqi[i]
			rssiX[x] <- rssi[i]
			distX[x] <- distance(fromid[i],toid[i])
			x<-x+1		
		}
		
	}

	filename <- "distance-lqi-rssi.ps" 
	postscript(filename, family = "NimbusSan")

	maintitle <- paste("Distance / LQI / RSSI")
	
	
	subtitle <- paste("LQI mean :",mean(lqiX),"| LQI var :",var(lqiX),"| RSSI mean :",mean(rssiX),"| RSSI var :",var(rssiX),"| #mesures :",len,"| #nodes :19" )
	
	layout(matrix(1:3, 3, 1),heights=c(1,1,2))
	
	
	plot(density(lqiX),col = "dark red",xlim=c(260,220))
	plot(density(rssiX),col = "dark blue",xlim=c(260,220))
	
	plot(lqiX,distX,main=maintitle,sub=subtitle,ylab="Distance Between nodes",xlab="LQI value",pch=20, xlim=c(260,220) , col = "dark red")
	points(rssiX,distX,col="dark blue",pch = 20)
	legend(x = 260, y = 3, col = c("dark blue", "dark red"),pch = c(20,20), lty = 1,legend = c("RSSI", "LQI"))



	dev.off()



	
}




plotDistRSSILQIREG <- function() {


   inp1 <- scan("N1.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")

  # cmdscale(d, k = 2, eig = FALSE, add = FALSE, x.ret = FALSE)
  # as.dist(m, diag = FALSE, upper = FALSE)
  # dissimMatrix <- matrix with lower triangle = dissimilarities
  
 	ji <- inp1$lqi > 128
	inp1$lqi[ji] = 383 - inp1$lqi[ji]
	inp1$lqi[!ji] = 128 - inp1$lqi[!ji]
  
  lqis <- numeric()
  lqiX <- numeric()
  distX <- numeric()
  
  
  len = 10000 #length(inp1$src)
  
  y <- 0
  
  for (i in 2:19) {
    for (j in (i+1):20) {
        x <- 0
        for (k in 1:len) {
          if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
            lqis[x] <- inp1$lqi[k]
            x<-x+1 
          }
        }
        lqiX[y] <- mean(lqis)
        distX[y] <- distance(i,j)
        y <- y+1        
    }
  
  
  }
  lin <- lm(distX ~ lqiX)

	maintitle <- paste("Distance / mean LQI")	
  plot(lqiX,distX,main=maintitle,ylab="Distance Between nodes",xlab="LQI value",pch=3, col = "dark red")
  
  mytext1 <- paste("LQI mean :",mean(lqiX),"LQI var :",var(lqiX),"#mesures :",length(distX))
  mytext2 <- paste("#nodes : 19","regline intercept :",lin$coefficients[1],"regline lqiX :",lin$coefficients[2])

  mtext(mytext1, side = 1,line=2)
  mtext(mytext2, side = 1,line=4) 
  
  summary(lin)
  print (lin)

	abline( coef = lin$coefficients )

	
}






#	NETWORK TOPOLOGY

# 	5	9	13	17		
#
# 	4	8	12	16	20	< 
#						| vdist
# 	3	7	11	15	19	<
#
# 	2	6	10	14	18
#	<-hdist->

#right now we'll say hdist = 1
#and vdist = 1
#But this could measured in the biblio

#coord<-function(n) {

#xi<-(n-2)%%4
#yi<-(n-2)%/%4

#c(xi,yi)
#}

#dist<-function(ni,nj) {sqrt(sum(coord(ni)-coord(nj)^2))}


#	col	
#	0  1 2  3  4
	
#lig 3	3 7 11 15 
#    2	2 6 10 14 18
#    1	1 5 9  13 17
#    0	0 4 8  12 16


#ddist <- sqrt((hdist ^ 2)+(vdist ^ 2))


#returns the distance between 2 nodes (oracle)
distance <- function(AnodeId,BnodeId) {
hdist <- 1.5
vdist <- 1

	
	if (AnodeId == BnodeId) {
		return(0)
	}
	
	#to begin at 0
	A <- AnodeId - 2
	B <- BnodeId - 2
	
	dist <- 0
	

	if (A > B) {
		tmp = B;
		B = A;
		A = tmp;
	} #now A is everytime the node with smaller nodeId   
	
	Acol <- A %/% 4 
	Alig <- A %% 4
	Bcol <- B %/% 4 
	Blig <- B %% 4
	
	if (Acol == Bcol) {
		return ((Blig - Alig) * vdist)
	}
	
	if (Alig == Blig) {
		return ((Bcol - Acol) * hdist)
	}
	
	
	#if we arrive here both nodes are neithwarningser same lig neither same col

	if (Alig < Blig) { 
		return (sqrt((((Bcol - Acol)*hdist)^2) + (((Blig - Alig)*vdist)^2)) )
	}
	else { 
		return (sqrt((((Bcol - Acol)*hdist)^2) + (((Alig - Blig)*vdist)^2)) )
	}
}
localizeMDSRSSI <- function() {
  inp1 <- scan("N2.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")
  
  mat <- array(0, dim=c(19,19))
  
  diag(mat) <- 0
  
  rssis <- numeric()
  
  len = 10000 #length(inp1$src)
  
  for (i in 2:19) {
    for (j in (i+1):20) {
        x <- 0
        for (k in 1:len) {
          if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
            rssis[x] <- inp1$rssi[k]
            x<-x+1 
          }
        }
        mat[j-1,i-1] <- mean(rssis)
    }
  
  
  }
  
  real.x <- numeric()
  real.y <- numeric()
  real.x[1] <- 0
  real.y[1] <- 0
  real.x[2] <- 0
  real.y[2] <- 1
  real.x[3] <- 0
  real.y[3] <- 2  
  real.x[4] <- 0
  real.y[4] <- 3

  real.x[5] <- 1.5
  real.y[5] <- 0
  real.x[6] <- 1.5
  real.y[6] <- 1
  real.x[7] <- 1.5
  real.y[7] <- 2  
  real.x[8] <- 1.5
  real.y[8] <- 3
  
  real.x[9] <- 3
  real.y[9] <- 0
  real.x[10] <- 3
  real.y[10] <- 1
  real.x[11] <- 3
  real.y[11] <- 2  
  real.x[12] <- 3
  real.y[12] <- 3
  
  real.x[13] <- 4.5
  real.y[13] <- 0
  real.x[14] <- 4.5
  real.y[14] <- 1
  real.x[15] <- 4.5
  real.y[15] <- 2  
  real.x[16] <- 4.5
  real.y[16] <- 3

  real.x[17] <- 6
  real.y[17] <- 0
  real.x[18] <- 6
  real.y[18] <- 1
  real.x[19] <- 6
  real.y[19] <- 2

  real.x <- real.x - mean(real.x)
  real.y <- real.y - mean(real.y)    
  
  mds <- cmdscale(as.dist(mat),add=TRUE,eig=TRUE,k=18)
  print("Eigen values MDS RSSI")
  print(mds$eig)
  
  x <- mds$points[,1]
  y <- -mds$points[,2]
  
  xy <- cbind(x,y)
  xoyo <-cbind(real.x,real.y) 
  
  good <- procrustes(xoyo, xy)
  
  mse <-  sqrt(good$ss/19)
  
  plotab <- good$Yrot
  
  x11()
  plot(good,main='MDS localisation with RSSI',sub=paste('position MSE = ',mse))
  browser()
  
  
}
localizeMDSLQI <- function() {
  inp1 <- scan("N2.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")

  # cmdscale(d, k = 2, eig = FALSE, add = FALSE, x.ret = FALSE)
  # as.dist(m, diag = FALSE, upper = FALSE)
  # dissimMatrix <- matrix with lower triangle = dissimilarities
  
 	ji <- inp1$lqi > 128
	inp1$lqi[ji] = 383 - inp1$lqi[ji]
	inp1$lqi[!ji] = 128 - inp1$lqi[!ji]
  
  mat <- array(0, dim=c(19,19))
  matb <- array(0, dim=c(19,19))
  mat2 <- array(0, dim=c(19,19))
  
  diag(mat) <- 0
  
  lqis <- numeric()
  
  len = 10000 #length(inp1$src)
  
  for (i in 2:19) {
    for (j in (i+1):20) {
        x <- 0
        for (k in 1:len) {
          if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
            lqis[x] <- inp1$lqi[k]
            x<-x+1 
          }
        }
#        print(lqis)
        #mat[j-1,i-1] <- (-10.50084 + (mean(lqis) * 0.09973)) #to get dissimilarities
        mat[j-1,i-1] <- mean(lqis)
        #mat[i-1,j-1] <- mat[j-1,i-1]
        #matb[j-1,i-1] <- (-11.04994 + (mean(lqis) * 0.10467)) #to get dissimilarities
        #matb[i-1,j-1] <- matb[j-1,i-1]        
        
        #mat2[i-1,j-1] <- distance(i,j)
        #mat2[j-1,i-1] <- mat2[i-1,j-1]          
    }
  
  
  }
  
#  error <- sqrt((mat2 - mat)^2)
#  print("lqi based estimated distance")
#  print(mat) 
#  print("oracle distance")
#  print(mat2)
#  print("error")
#  print(error)
#  print("erreur moyenne")
#  print(mean(error))
#  print("erreur var")
#  print(var(error))


  real.x <- numeric()
  real.y <- numeric()
  real.x[1] <- 0
  real.y[1] <- 0
  real.x[2] <- 0
  real.y[2] <- 1
  real.x[3] <- 0
  real.y[3] <- 2  
  real.x[4] <- 0
  real.y[4] <- 3

  real.x[5] <- 1.5
  real.y[5] <- 0
  real.x[6] <- 1.5
  real.y[6] <- 1
  real.x[7] <- 1.5
  real.y[7] <- 2  
  real.x[8] <- 1.5
  real.y[8] <- 3
  
  real.x[9] <- 3
  real.y[9] <- 0
  real.x[10] <- 3
  real.y[10] <- 1
  real.x[11] <- 3
  real.y[11] <- 2  
  real.x[12] <- 3
  real.y[12] <- 3
  
  real.x[13] <- 4.5
  real.y[13] <- 0
  real.x[14] <- 4.5
  real.y[14] <- 1
  real.x[15] <- 4.5
  real.y[15] <- 2  
  real.x[16] <- 4.5
  real.y[16] <- 3

  real.x[17] <- 6
  real.y[17] <- 0
  real.x[18] <- 6
  real.y[18] <- 1
  real.x[19] <- 6
  real.y[19] <- 2

  real.x <- real.x - mean(real.x)
  real.y <- real.y - mean(real.y)    
  
#  mds <- cmdscale(as.dist(mat))
  
  mds <- cmdscale(as.dist(mat),add=TRUE,eig=TRUE,k=18)
  print("Eigen values MDS LQI")
  print(mds$eig)
  
  x <- mds$points[,1]
  y <- -mds$points[,2]
  #x <- x - mean(x)
  #y <- y - mean(y)


#  mdso <- cmdscale(mat2,add=TRUE,eig=TRUE,k=18)
#  print("Eigen values MDS ORACLE")
#  print(mdso$eig)

#  xo <- mdso$points[,1]
#  yo <- -mdso$points[,2]

  #xo <- xo - mean(xo)
  #yo <- yo - mean(yo)

  #xiyi <- cbind(x,y)
  #ximyi <- cbind(y,-x)
  
  xy <- cbind(x,y)
  xoyo <-cbind(real.x,real.y) 
  
  #totx <- rbind(xiyi,ximyi)
  
 #toty <- rbind(t(t(xo)),t(t(yo)))
  
  #rot <- lm(toty ~ totx - 1)
  
  #browser()
  
  #for (i in 1:19) {
  #    x[i] = (x[i]*rot$coefficients[1])  + (y[i]*rot$coefficients[2])
  #    y[i] = (-x[i]*rot$coefficients[2]) + (y[i]*rot$coefficients[1])
  #}

  good <- procrustes(xoyo, xy,scale = TRUE)
  
  good2 <- procOPA(xoyo,xy)
  
  mse <-  sqrt(good$ss/19)
  
  plotab <- good$Yrot
  
  #browser()
  x11()
  plot(good,main='MDS localisation with LQI',sub=paste('position MSE = ',mse))

  x11()
  plot(good2$Bhat,main='MDS localisation with LQI',sub=paste('position MSE = ',sqrt(good2$OSS/19)))
  #plot (plotab,col="blue",main="localisatio MDS experience NO5",xlim=c(-3,3),ylim=c(-3,3)) #,
  #text (plotab,labels=2:20,col="blue")


  #points (xoyo,col="red")
  #text (xoyo,labels=2:20,col="red")

  browser()
  
#  str(mds)
#
#  svdm <- svd(mds$x)
#  
#  str (svdm)
#  
#  svdm$d <- sqrt(svdm$d)
#  
#  eig <- eigen(svdm$u * svdm$d,TRUE )
#  
#  str(eig)
#  
#   x <- eig$values[1] * eig$vectors[1,]
#   y <- eig$values[2] * eig$vectors[2,]
   

  
  
#  print(mds)# contient les coordonnes des points
#  
#  x <- mds$points[,1]
#  y <- -mds$points[,2]
#  
# plot (x,y,col="blue") #,xlim=c(-3,3),ylim=c(-2,2)
# text (x,y,labels=2:20,col="blue")
#

  
  #browser()
  

  
  # 1 avoir la matrice P avec Pij = distance estime de i  j
  # 2 B <- shift P to the center ??
  # 3 calculer SVD(B) = VAV
  # 4 matrice coordones X = V(A^1/2)
  # retenir les 3 plus grande eigenvalues/eigenvectors de X  nous donne une solution
}     

localizeMDSREGLQI <- function() {
  inp1 <- scan("N2.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")

  # cmdscale(d, k = 2, eig = FALSE, add = FALSE, x.ret = FALSE)
  # as.dist(m, diag = FALSE, upper = FALSE)
  # dissimMatrix <- matrix with lower triangle = dissimilarities
  
 	ji <- inp1$lqi > 128
	inp1$lqi[ji] = 383 - inp1$lqi[ji]
	inp1$lqi[!ji] = 128 - inp1$lqi[!ji]
  
  mat <- array(0, dim=c(19,19))
  matb <- array(0, dim=c(19,19))
  mat2 <- array(0, dim=c(19,19))
  
  diag(mat) <- 0
  
  lqis <- numeric()
  
  len = 10000 #length(inp1$src)
  
  for (i in 2:19) {
    for (j in (i+1):20) {
        x <- 0
        for (k in 1:len) {
          if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
            lqis[x] <- inp1$lqi[k]
            x<-x+1 
          }
        }
#        print(lqis)
        mat[j-1,i-1] <- (-10.50084 + (mean(lqis) * 0.09973)) #to get dissimilarities
        #mat[j-1,i-1] <- mean(lqis)
        #mat[i-1,j-1] <- mat[j-1,i-1]
        #matb[j-1,i-1] <- (-11.04994 + (mean(lqis) * 0.10467)) #to get dissimilarities
        #matb[i-1,j-1] <- matb[j-1,i-1]        
        
        #mat2[i-1,j-1] <- distance(i,j)
        #mat2[j-1,i-1] <- mat2[i-1,j-1]          
    }
  
  
  }
  
#  error <- sqrt((mat2 - mat)^2)
#  print("lqi based estimated distance")
#  print(mat) 
#  print("oracle distance")
#  print(mat2)
#  print("error")
#  print(error)
#  print("erreur moyenne")
#  print(mean(error))
#  print("erreur var")
#  print(var(error))


  real.x <- numeric()
  real.y <- numeric()
  real.x[1] <- 0
  real.y[1] <- 0
  real.x[2] <- 0
  real.y[2] <- 1
  real.x[3] <- 0
  real.y[3] <- 2  
  real.x[4] <- 0
  real.y[4] <- 3

  real.x[5] <- 1.5
  real.y[5] <- 0
  real.x[6] <- 1.5
  real.y[6] <- 1
  real.x[7] <- 1.5
  real.y[7] <- 2  
  real.x[8] <- 1.5
  real.y[8] <- 3
  
  real.x[9] <- 3
  real.y[9] <- 0
  real.x[10] <- 3
  real.y[10] <- 1
  real.x[11] <- 3
  real.y[11] <- 2  
  real.x[12] <- 3
  real.y[12] <- 3
  
  real.x[13] <- 4.5
  real.y[13] <- 0
  real.x[14] <- 4.5
  real.y[14] <- 1
  real.x[15] <- 4.5
  real.y[15] <- 2  
  real.x[16] <- 4.5
  real.y[16] <- 3

  real.x[17] <- 6
  real.y[17] <- 0
  real.x[18] <- 6
  real.y[18] <- 1
  real.x[19] <- 6
  real.y[19] <- 2

  real.x <- real.x - mean(real.x)
  real.y <- real.y - mean(real.y)    
  
#  mds <- cmdscale(as.dist(mat))
  
  mds <- cmdscale(as.dist(mat),add=TRUE,eig=TRUE,k=18)
  print("Eigen values MDS LQI")
  print(mds$eig)
  
  x <- mds$points[,1]
  y <- -mds$points[,2]
  #x <- x - mean(x)
  #y <- y - mean(y)


#  mdso <- cmdscale(mat2,add=TRUE,eig=TRUE,k=18)
#  print("Eigen values MDS ORACLE")
#  print(mdso$eig)

#  xo <- mdso$points[,1]
#  yo <- -mdso$points[,2]

  #xo <- xo - mean(xo)
  #yo <- yo - mean(yo)

  #xiyi <- cbind(x,y)
  #ximyi <- cbind(y,-x)
  
  xy <- cbind(x,y)
  xoyo <-cbind(real.x,real.y) 
  
  #totx <- rbind(xiyi,ximyi)
  
 #toty <- rbind(t(t(xo)),t(t(yo)))
  
  #rot <- lm(toty ~ totx - 1)
  
  #browser()
  
  #for (i in 1:19) {
  #    x[i] = (x[i]*rot$coefficients[1])  + (y[i]*rot$coefficients[2])
  #    y[i] = (-x[i]*rot$coefficients[2]) + (y[i]*rot$coefficients[1])
  #}

  good <- procrustes(xoyo, xy)
  
  mse <-  sqrt(good$ss/19)
  
  plotab <- good$Yrot
  
  #browser()
  x11()
  plot(good,main='MDS localisation with DIST = F(LQI)',sub=paste('position MSE = ',mse))
  #plot (plotab,col="blue",main="localisatio MDS experience NO5",xlim=c(-3,3),ylim=c(-3,3)) #,
  #text (plotab,labels=2:20,col="blue")


  #points (xoyo,col="red")
  #text (xoyo,labels=2:20,col="red")

  browser()
  
#  str(mds)
#
#  svdm <- svd(mds$x)
#  
#  str (svdm)
#  
#  svdm$d <- sqrt(svdm$d)
#  
#  eig <- eigen(svdm$u * svdm$d,TRUE )
#  
#  str(eig)
#  
#   x <- eig$values[1] * eig$vectors[1,]
#   y <- eig$values[2] * eig$vectors[2,]
   

  
  
#  print(mds)# contient les coordonnes des points
#  
#  x <- mds$points[,1]
#  y <- -mds$points[,2]
#  
# plot (x,y,col="blue") #,xlim=c(-3,3),ylim=c(-2,2)
# text (x,y,labels=2:20,col="blue")
#

  
  #browser()
  

  
  # 1 avoir la matrice P avec Pij = distance estime de i  j
  # 2 B <- shift P to the center ??
  # 3 calculer SVD(B) = VAV
  # 4 matrice coordones X = V(A^1/2)
  # retenir les 3 plus grande eigenvalues/eigenvectors de X  nous donne une solution
}     



localizeMDSNO5 <- function() {
  inp1 <- scan("N2.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")

 	ji <- inp1$lqi > 128
	inp1$lqi[ji] = 383 - inp1$lqi[ji]
	inp1$lqi[!ji] = 128 - inp1$lqi[!ji]
  
  mat <- array(0, dim=c(20,20))
  
  lqis <- numeric()
  
  len <- length(inp1$src)
  
  for (i in 1:20) {
    for (j in (i+1):20) {
        x <- 0
        for (k in 1:len) {
          if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
            lqis[x] <- inp1$lqi[k]
            x<-x+1 
          }
        }
#        print(lqis)
        mat[j-1,i-1] <- (-10.50084 + (mean(lqis) * 0.09973)) #to get dissimilarities
        mat[i-1,j-1] <- mat[j-1,i-1]
    }
  }
 
  mds <- cmdscale(mat,add=TRUE,eig=TRUE,k=18)
 
  x <- mds$points[,1]
  y <- -mds$points[,2]

  plot (x,y,col="blue",pch=".",main="localisation MDS experience NO5") #,xlim=c(-3,3),ylim=c(-2,2)
  text (x,y,labels=1:20,col="blue")
}     

plotErrorsNode <- function() {
 inp1 <- scan("N1.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")

  # cmdscale(d, k = 2, eig = FALSE, add = FALSE, x.ret = FALSE)
  # as.dist(m, diag = FALSE, upper = FALSE)
  # dissimMatrix <- matrix with lower triangle = dissimilarities
  
 	ji <- inp1$lqi > 128
	inp1$lqi[ji] = 383 - inp1$lqi[ji]
	inp1$lqi[!ji] = 128 - inp1$lqi[!ji]
  
  mat <- array(0, dim=c(19,19))
  matb <- array(0, dim=c(19,19))
  mat2 <- array(0, dim=c(19,19))
  
  lqis <- numeric()
  errors <- array(0,dim=c(19,20))
  
  len = 10000 #length(inp1$src)
  
  for (i in 2:19) {
    for (j in (i+1):20) {
        x <- 0
        for (k in 1:len) {
          if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
            lqis[x] <- inp1$lqi[k]
            x<-x+1 
          }
        }
#        print(lqis)
        mat[j-1,i-1] <- (-10.50084 + (mean(lqis) * 0.09973)) #to get dissimilarities
        mat[i-1,j-1] <- mat[j-1,i-1]
        matb[j-1,i-1] <- (-11.04994 + (mean(lqis) * 0.10467)) #to get dissimilarities
        matb[i-1,j-1] <- matb[j-1,i-1]        
        
        mat2[i-1,j-1] <- distance(i,j)
        mat2[j-1,i-1] <- mat2[i-1,j-1]          
    }
   }
   
 print(mat)
 


 for (i in 2:20) {
    x <-1
    for (j in 2:20) {
       if ( i != j ) {
         errors[i-1,x] <-  sqrt((mat2[i-1,j-1] - mat[i-1,j-1])^2)
         x <- x+1
       }
    }
 
 }

  
  errorsVars <- numeric()
  errorsMeans <- numeric()
  
  for (l in 2:20) {
      errorsMeans[l] <- mean(errors[l-1,])
     errorsVars[l] <- var(errors[l-1,])
  }

  x11()  
  layout(matrix(1:2, 2, 1))
 
  barplot(errorsMeans,main ="nodes distance estimation error mean",col = hsv((1:19)/20,.5,.5))
  #text(seq(2,24,by=1.19),0.1,labels=2:20,col="white")

  barplot(errorsVars,main = "nodes distance estimation error var",col = hsv((1:19)/20,.5,.5))
  #text(seq(2,24,by=1.19),0.1,labels=2:20,col="white")

        

}

LocaliseLAT <- function() {

  inp1 <- scan("N1.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")
  
  j <- inp1$lqi > 128
inp1$lqi[j] = 383 - inp1$lqi[j]
inp1$lqi[!j] = 128 - inp1$lqi[!j]

  # cmdscale(d, k = 2, eig = FALSE, add = FALSE, x.ret = FALSE)
  # as.dist(m, diag = FALSE, upper = FALSE)
  # dissimMatrix <- matrix with lower triangle = dissimilarities
  
  startNodes = c(2,5,20,16)
  
 	ji <- inp1$lqi > 128
	inp1$lqi[ji] = 383 - inp1$lqi[ji]
	inp1$lqi[!ji] = 128 - inp1$lqi[!ji]
  
  mat <- array(0, dim=c(19,19))
  matb <- array(0, dim=c(19,19))
  mat2 <- array(0, dim=c(19,19))
  
  lqis <- numeric()
  
  len = 10000 #length(inp1$src)
  
  for (i in 2:19) {
    for (j in (i+1):20) {
        x <- 0
        for (k in 1:len) {
          if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
            lqis[x] <- inp1$lqi[k]
            x<-x+1 
          }
        }
#        print(lqis)
        mat[j-1,i-1] <- (-10.50084 + (mean(lqis) * 0.09973)) #to get dissimilarities
        mat[i-1,j-1] <- mat[j-1,i-1]
        matb[j-1,i-1] <- (-11.04994 + (mean(lqis) * 0.10467)) #to get dissimilarities
        matb[i-1,j-1] <- matb[j-1,i-1]        
        
        mat2[i-1,j-1] <- distance(i,j)
        mat2[j-1,i-1] <- mat2[i-1,j-1]          
    }
  
  
  }
  
  
  #get the real position of anchors
  
  #for each node not localized
    
  
  

}        



locaMDSmultiRF <- function() {
  #inp1 <- scan("neighbors.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")

  #mettre dans des vecteurs le donnes par rflevel power
  
  values <- list()
  reg.Errors <- numeric()
  reg.Intercepts <- numeric()
  reg.Lqis <- numeric()

  mds.mse <- numeric()
  real.dist<-array(NA,c(19,19))
  diag(real.dist) <- 0.0  
  
  good <- list()
  
  #We put the values in a list indexed by Radio Power
  for (x in 1:31) {
    values[[x]] <- c(-10,-10)
  }
 
  for (i in 1:length(inp1$idx)) {
    aa <- inp1$seqno[i] %/% 10
    if (aa > 30) {  aa <- aa %% 31 }
    if ( values[[(aa + 1)]][1] == -10 ) {
      values[[(aa + 1)]] <- c(inp1$seqno[i],inp1$src[i],inp1$pongsrc[i],inp1$lqi[i])
    } else {
      values[[(aa + 1)]] <- rbind(values[[(aa + 1)]],c(inp1$seqno[i],inp1$src[i],inp1$pongsrc[i],inp1$lqi[i]))      
    }

  } 
  #We put the real distances in real.dist
  for (i in 2:19) {
    for (j in (i+1):20) {
          real.dist[i-1,j-1] <- distance(i,j)
          real.dist[j-1,i-1] <- real.dist[i-1,j-1]          
    }
  }
  #we put the positions calculated from the real distance by mds in real.x real.y
  #browser()
  #mds <- cmdscale(real.dist,add=TRUE,eig=TRUE,k=18)
 
  #real.x <- mds$points[,1]
  #real.y <- -mds$points[,2]
  
  #we try to center on origin
  #real.x <- real.x - mean(real.x)
  #real.y <- real.y - mean(real.y)
  real.x <- numeric()
  real.y <- numeric()
  real.x[1] <- 0
  real.y[1] <- 0
  real.x[2] <- 0
  real.y[2] <- 1
  real.x[3] <- 0
  real.y[3] <- 2  
  real.x[4] <- 0
  real.y[4] <- 3

  real.x[5] <- 1.5
  real.y[5] <- 0
  real.x[6] <- 1.5
  real.y[6] <- 1
  real.x[7] <- 1.5
  real.y[7] <- 2  
  real.x[8] <- 1.5
  real.y[8] <- 3
  
  real.x[9] <- 3
  real.y[9] <- 0
  real.x[10] <- 3
  real.y[10] <- 1
  real.x[11] <- 3
  real.y[11] <- 2  
  real.x[12] <- 3
  real.y[12] <- 3
  
  real.x[13] <- 4.5
  real.y[13] <- 0
  real.x[14] <- 4.5
  real.y[14] <- 1
  real.x[15] <- 4.5
  real.y[15] <- 2  
  real.x[16] <- 4.5
  real.y[16] <- 3

  real.x[17] <- 6
  real.y[17] <- 0
  real.x[18] <- 6
  real.y[18] <- 1
  real.x[19] <- 6
  real.y[19] <- 2

  real.x <- real.x - mean(real.x)
  real.y <- real.y - mean(real.y)
         
  # pour tous les radios power : calculer la droite de regression
  for (radf in 1:31) { 


    distX <- numeric()
    lqiX <- numeric()
	
    len <- length(values[[radf]][,1])	
    x<- 0
  
    mean.lqi<-array(NA,c(19,19))
    mean.dist<-array(NA,c(19,19))
    for (i in 2:20) {
     for (j in 2:20) {
      tmp<-mean(values[[radf]][(values[[radf]][,2]==i)&(values[[radf]][,3]==j) | (values[[radf]][,2]==j)&(values[[radf]][,3]==i) ,4])
      if (!is.nan(tmp)) mean.lqi[i-1,j-1]<-tmp
      mean.dist[i-1,j-1]<-distance(i,j)
     }
    }
	  
    distX<-as.numeric(mean.dist)
    lqiX<-as.numeric(mean.lqi)
    lin <- lm(distX ~ lqiX,na.action=na.exclude)
    
    #x11()
    #plot(lqiX,distX,col = hsv(radf/31,.5,.5),pch=20,main=paste("lqi/dist rfpower= ",radf))
    #abline( coef = lin$coefficients , col = hsv(radf/31,.5,.5))
    reg.Intercepts[radf] <- lin$coefficients[1]
    reg.Lqis[radf] <- lin$coefficients[2]
    reg.Errors[radf] <- sum(lin$residuals^2)/length(lin$residuals) 

    #browser()
 }
  # pour tous les radios levels
  for (radf in 2:31) { 
      act.lqi<-array(NA,c(19,19))
      act.dist<-array(NA,c(19,19))
      comp.dist<-array(NA,c(19,19))
      
      diag(act.dist) <- 0.0
      
      #remplir la matrice de distance avec les valeurs que l'on a 
      for (i in 2:20) {
        for (j in 2:20) {
            if (i !=j ) {
            
              tmp<-mean(values[[radf]][(values[[radf]][,2]==i)&(values[[radf]][,3]==j) | (values[[radf]][,2]==j)&(values[[radf]][,3]==i),4])
              if (!is.nan(tmp)) {
                act.dist[i-1,j-1]<- reg.Intercepts[radf] + reg.Lqis[radf] * tmp
                act.dist[j-1,i-1]<- act.dist[i-1,j-1]
              }
            }
        }
      }
      #remplir les donnes manquantes avec le shortest path length
      comp.dist <- allShortestPaths(act.dist)$length
      
      
      #appliquer le mds
      mds <- cmdscale(comp.dist,add=TRUE,eig=TRUE,k=18)
 
      x <- mds$points[,1]
      y <- -mds$points[,2]
      
      #center on origin
      #x <- x - mean(x)
      #y <- y - mean(y)

      #rotation et scaling des positions rsultantes pour s'adapter au "bon plan"
      
      xy <- cbind(x,y)
      xoyo <-cbind(real.x,real.y) 
  
      #browser()
  
      good[[radf]] <- procrustes(xoyo, xy, scale=T)
  
      #calcul de l'erreur par rapport au bon plan
      mds.mse[radf] <-  sqrt(good[[radf]]$ss/19)
      
      if (radf == 2) {
        plot(good[[radf]]$Yrot,col = hsv(radf/31,.7,.5),pch=20,xlim=c(-3,3),ylim=c(-3,3))
      } else  {
        points(good[[radf]]$Yrot,col = hsv(radf/31,.7,.5),pch=20)
      }
      text (good[[radf]]$Yrot,labels=2:20,col = hsv(radf/31,.7,.5))
  

  }
        points(real.x,real.y,pch=21)
        text(real.x,real.y,labels=2:20)

  
  vmin <- mds.mse[2] 
  imin <- 2
  vmax <- mds.mse[2] 
  imax <- 2
 for (i in 3:19) {
     if ( mds.mse[i] < vmin ) {
        vmin <- mds.mse[i]
        imin <- i 
     }
     if ( mds.mse[i] > vmax ) {
        vmax <- mds.mse[i]
        imax <- i 
     }

  }
  x11()
  plot(good[[imin]])
  x11()
  barplot(mds.mse)
  x11()
  plot(good[[imax]])
  
  browser()
  errors<-data.frame(residuals(good[[2]]))
  for (i in 3:31) {
   errors<-data.frame(errors,residuals(good[[i]]))
  }
  colnames(errors)<-2:31
  par(las=2)
  boxplot(errors)
  #TO TRY !!
  # make a kind of mean between all the positions returned by the 31 MDS/PROCRUSTES for each node
  # calculate if better error !

}

    #2 calculer erreur de regression -> tableau d'erreursRegression[31]
    #3 remplir la matrice de distance avec tout ce qu'on a
    #4 complter la matrice de distance pr les donnes manquantes avec shortest path
    #5 miroirer cette matrice
    #6 faire mds sur matrice
    #7 scale et rotation du tableau de positions pour harmoniser avec le vrai tableau
    #8 calculer l'erreur de positionnement -> tableau d'erreursPosition[31]
    
  #
#    mat <- array(NA, dim=c(19,19)) 
#    diag(mat) <- 0
#    lqis <- numeric()      
#    for (i in 2:19) {
#      for (j in (i+1):20) {
#        x <- 0
#        for (k in 1:10) {
#          if (((inp1$seqno %/% 10) + 1) ==  radf) {
#            if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
#              lqis[x] <- inp1$lqi[k]
#              x<-x+1 
#            }          
#          }
#        }
#        mat[j-1,i-1] <- (-10.50084 + (mean(lqis) * 0.09973)) #to get dissimilarities
#      }
#    }
#  }
#

plotDistLQI2 <- function() {

  inp1 <- scan("neighbors.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")
  
  #j <- inp1$lqi > 128
	#inp1$lqi[j] = 383 - inp1$lqi[j]
	#inp1$lqi[!j] = 128 - inp1$lqi[!j]
	
	
	lqiX <- numeric()
	distX <- numeric()
	

	x <- 0

	len <- length(inp1$lqi)

	for (i in 1:len) {
		if (inp1$src[i] > 1 && inp1$pongsrc[i] > 1) {
		  d <-  (inp1$seqno[i] %% 10)
			if (d == 0) {
        lqiX[x] <- inp1$lqi[i]
  			distX[x] <- distance(inp1$src[i],inp1$pongsrc[i])
  			x<-x+1
       }	
		}
		
	}

  #browser()
 
#  i <- (distX < 5 && distX > 4)
#  distX <-distX[i] 
#  lqiX <- lqiX[i]
	#filename <- "distance-lqi.ps" 
	#postscript(filename, family = "NimbusSan")
	
	x11()

  lin <- lm(distX ~ lqiX)

	maintitle <- paste("Distance / LQI")	
  plot(lqiX,distX,main=maintitle,ylab="Distance Between nodes",xlab="LQI value",pch=3, col = "dark red")
 
  mytext1 <- paste("LQI mean :",mean(lqiX),"LQI var :",var(lqiX),"#mesures :",length(distX))
  mytext2 <- paste("#nodes : 19","regline intercept :",lin$coefficients[1],"regline lqiX :",lin$coefficients[2])

  mtext(mytext1, side = 1,line=2)
  mtext(mytext2, side = 1,line=4)  
	
	
	abline( coef = lin$coefficients  )
	
	#print (lin$coefficients)
	#print (lin$residuals)
	
	
	#dev.off()



	
}






locaMDSmultiRFRSSI <- function() {
  #inp1 <- scan("neighbors.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")

  #mettre dans des vecteurs le donnes par rflevel power
  
  values <- list()
  reg.Errors <- numeric()
  reg.Intercepts <- numeric()
  reg.Lqis <- numeric()

  mds.mse <- numeric()
  real.dist<-array(NA,c(19,19))
  diag(real.dist) <- 0.0  
  
  good <- list()
  
  #We put the values in a list indexed by Radio Power
  for (x in 1:31) {
    values[[x]] <- c(-10,-10)
  }
 
  for (i in 1:length(inp1$idx)) {
    aa <- inp1$seqno[i] %/% 10
    if (aa > 30) {  aa <- aa %% 31 }
    if ( values[[(aa + 1)]][1] == -10 ) {
      values[[(aa + 1)]] <- c(inp1$seqno[i],inp1$src[i],inp1$pongsrc[i],inp1$rssi[i])
    } else {
      values[[(aa + 1)]] <- rbind(values[[(aa + 1)]],c(inp1$seqno[i],inp1$src[i],inp1$pongsrc[i],inp1$rssi[i]))      
    }

  } 
  #We put the real distances in real.dist
  for (i in 2:19) {
    for (j in (i+1):20) {
          real.dist[i-1,j-1] <- distance(i,j)
          real.dist[j-1,i-1] <- real.dist[i-1,j-1]          
    }
  }
  #we put the positions calculated from the real distance by mds in real.x real.y
  #browser()
  #mds <- cmdscale(real.dist,add=TRUE,eig=TRUE,k=18)
 
  #real.x <- mds$points[,1]
  #real.y <- -mds$points[,2]
  
  #we try to center on origin
  #real.x <- real.x - mean(real.x)
  #real.y <- real.y - mean(real.y)
  real.x <- numeric()
  real.y <- numeric()
  real.x[1] <- 0
  real.y[1] <- 0
  real.x[2] <- 0
  real.y[2] <- 1
  real.x[3] <- 0
  real.y[3] <- 2  
  real.x[4] <- 0
  real.y[4] <- 3

  real.x[5] <- 1.5
  real.y[5] <- 0
  real.x[6] <- 1.5
  real.y[6] <- 1
  real.x[7] <- 1.5
  real.y[7] <- 2  
  real.x[8] <- 1.5
  real.y[8] <- 3
  
  real.x[9] <- 3
  real.y[9] <- 0
  real.x[10] <- 3
  real.y[10] <- 1
  real.x[11] <- 3
  real.y[11] <- 2  
  real.x[12] <- 3
  real.y[12] <- 3
  
  real.x[13] <- 4.5
  real.y[13] <- 0
  real.x[14] <- 4.5
  real.y[14] <- 1
  real.x[15] <- 4.5
  real.y[15] <- 2  
  real.x[16] <- 4.5
  real.y[16] <- 3

  real.x[17] <- 6
  real.y[17] <- 0
  real.x[18] <- 6
  real.y[18] <- 1
  real.x[19] <- 6
  real.y[19] <- 2

  real.x <- real.x - mean(real.x)
  real.y <- real.y - mean(real.y)
         
  # pour tous les radios power : calculer la droite de regression
  for (radf in 1:31) { 


    distX <- numeric()
    lqiX <- numeric()
	
    len <- length(values[[radf]][,1])	
    x<- 0
  
    mean.lqi<-array(NA,c(19,19))
    mean.dist<-array(NA,c(19,19))
    for (i in 2:20) {
     for (j in 2:20) {
      tmp<-mean(values[[radf]][(values[[radf]][,2]==i)&(values[[radf]][,3]==j) | (values[[radf]][,2]==j)&(values[[radf]][,3]==i) ,4])
      if (!is.nan(tmp)) mean.lqi[i-1,j-1]<-tmp
      mean.dist[i-1,j-1]<-distance(i,j)
     }
    }
	  
    distX<-as.numeric(mean.dist)
    lqiX<-as.numeric(mean.lqi)
    lin <- lm(distX ~ lqiX,na.action=na.exclude)
    
    #x11()
    #plot(lqiX,distX,col = hsv(radf/31,.5,.5),pch=20,main=paste("lqi/dist rfpower= ",radf))
    #abline( coef = lin$coefficients , col = hsv(radf/31,.5,.5))
    reg.Intercepts[radf] <- lin$coefficients[1]
    reg.Lqis[radf] <- lin$coefficients[2]
    reg.Errors[radf] <- sum(lin$residuals^2)/length(lin$residuals) 

    #browser()
 }
  # pour tous les radios levels
  for (radf in 2:31) { 
      act.lqi<-array(NA,c(19,19))
      act.dist<-array(NA,c(19,19))
      comp.dist<-array(NA,c(19,19))
      
      diag(act.dist) <- 0.0
      
      #remplir la matrice de distance avec les valeurs que l'on a 
      for (i in 2:20) {
        for (j in 2:20) {
            if (i !=j ) {
            
              tmp<-mean(values[[radf]][(values[[radf]][,2]==i)&(values[[radf]][,3]==j) | (values[[radf]][,2]==j)&(values[[radf]][,3]==i),4])
              if (!is.nan(tmp)) {
                #act.dist[i-1,j-1]<- reg.Intercepts[radf] + reg.Lqis[radf] * tmp
                act.dist[i-1,j-1]<- tmp
                act.dist[j-1,i-1]<- act.dist[i-1,j-1]
              }
            }
        }
      }
      #remplir les donnes manquantes avec le shortest path length
      comp.dist <- allShortestPaths(act.dist)$length
      
      
      #appliquer le mds
      mds <- cmdscale(comp.dist,add=TRUE,eig=TRUE,k=18)
 
      x <- mds$points[,1]
      y <- -mds$points[,2]
      
      #center on origin
      #x <- x - mean(x)
      #y <- y - mean(y)

      #rotation et scaling des positions rsultantes pour s'adapter au "bon plan"
      
      xy <- cbind(x,y)
      xoyo <-cbind(real.x,real.y) 
  
      #browser()
  
      good[[radf]] <- procrustes(xoyo, xy, scale=T)
  
      #calcul de l'erreur par rapport au bon plan
      mds.mse[radf] <-  sqrt(good[[radf]]$ss/19)
      
      if (radf == 2) {
        plot(good[[radf]]$Yrot,col = hsv(radf/31,.7,.5),pch=20,xlim=c(-3,3),ylim=c(-3,3))
      } else  {
        points(good[[radf]]$Yrot,col = hsv(radf/31,.7,.5),pch=20)
      }
      text (good[[radf]]$Yrot,labels=2:20,col = hsv(radf/31,.7,.5))
  

  }
        points(real.x,real.y,pch=21)
        text(real.x,real.y,labels=2:20)

  
  vmin <- mds.mse[2] 
  imin <- 2
  vmax <- mds.mse[2] 
  imax <- 2
 for (i in 3:19) {
     if ( mds.mse[i] < vmin ) {
        vmin <- mds.mse[i]
        imin <- i 
     }
     if ( mds.mse[i] > vmax ) {
        vmax <- mds.mse[i]
        imax <- i 
     }

  }
  x11()
  plot(good[[imin]])
  x11()
  barplot(mds.mse)
  x11()
  plot(good[[imax]])
  
  browser()
  errors<-data.frame(residuals(good[[2]]))
  for (i in 3:31) {
   errors<-data.frame(errors,residuals(good[[i]]))
  }
  colnames(errors)<-2:31
  par(las=2)
  boxplot(errors)
  #TO TRY !!
  # make a kind of mean between all the positions returned by the 31 MDS/PROCRUSTES for each node
  # calculate if better error !

}