/*
 * Calibrator.java
 *
 * Created on 12 mars 2007, 10:24
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author dwarfy
 */

package net.tinyos.mapviewer;

import java.io.IOException;
import net.tinyos.tools.CalibrationMsg;

import net.tinyos.util.*;
import net.tinyos.message.*;

import java.util.LinkedList;
import java.util.ListIterator;

public class Calibrator {
    MoteIF mote;
    public float coef;
    public float intercept;
    SerialReceiver S;
    private LinkedList<CalibrationMsg> cList;

    /** Creates a new instance of Calibrator */
    public Calibrator() {
        coef=-4.0f;
        intercept=2500.0f;
    }

    public void StartCalibration() {
        //send CalibrationMsg;
          try {
             CalibrationMsg CM = new CalibrationMsg();
             CM.set_sourceAnchorId((short)0);
             S.getMote().send(MoteIF.TOS_BCAST_ADDR,CM);
          } catch (IOException ioe) {
            System.err.println("Warning: Got IOException sending reset message: "+ioe);
            ioe.printStackTrace();
          }

        //init datastructures
    }

    public void StopCalibration() {
        //get list of calibration messages received
        cList = S.getCalibrationList();
        
        ListIterator it = cList.listIterator();
        CalibrationMsg cMsg;
        float sx=0,sy=0,s=0,sxx=0,sxy=0,del=0,lqi,dist;

        s = cList.size();

        
        while (it.hasNext()) {
            cMsg = (CalibrationMsg) it.next();

            lqi = (float)cMsg.get_lqi();
            dist = Config.Distance(cMsg.get_sourceAnchorId(),cMsg.get_otherAnchorId());

            sx  += lqi;
            sy  += dist;
            sxx += lqi*lqi;
            sxy += lqi*dist;
        }

        del = s*sxx - sx*sx;

        // Intercept
        intercept =  (sxx*sy -sx*sxy)/del;
        // Slope
        coef =  (s*sxy -sx*sy)/del;
        
        //dist = intercept + coef*lqi;
        //y = a + bx
        
        System.out.println("sx = ".concat(Float.toString(sx)));
        System.out.println("sx = ".concat(Float.toString(sy)));
        System.out.println("sxx = ".concat(Float.toString(sxx)));
        System.out.println("sxy = ".concat(Float.toString(sxy)));
        
        System.out.println("Coef = ".concat(Float.toString(coef)));
        System.out.println("Intercept = ".concat(Float.toString(intercept)));
        
    }

    public float getDistance(float lqi) {
      return (float)( intercept + (coef * lqi) );
    }

    public void setSerial(SerialReceiver Ser) {
        S=Ser;
    }
    
}
