/*
 * MapContainerPanel.java
 *
 * Created on 9 mars 2007, 15:24
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author dwarfy
 *
 */
package net.tinyos.mapviewer;

import javax.swing.*;
import javax.swing.text.*;

import java.awt.*;              //for layout managers and more
import java.awt.event.*; 

public class MapContainerPanel extends JPanel implements RefreshAble,ActionListener {
    MapPanel viewPane;
    Calibrator Cal;
    JPanel controlPane;
    RcvPanel rcvPane;
    JScrollPane scroller;
    JButton buttonPlus,buttonMoins,buttonCalib;
    JCheckBox historyCheck;
    JSlider slider3;
    JTextArea textArea;
    
    
    /** Creates a new instance of MapContainerPanel */
    public MapContainerPanel() {

              setLayout(new BorderLayout()); 
        viewPane = new MapPanel();
        viewPane.setBackground(Color.WHITE);
        
        rcvPane = new RcvPanel();
        
        scroller = new JScrollPane(viewPane);
        scroller.setPreferredSize(new Dimension(400,400));
        scroller.setMinimumSize(scroller.getPreferredSize());
        scroller.setMaximumSize(scroller.getPreferredSize());        
       /* viewPane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("View"),
                                BorderFactory.createEmptyBorder(5,5,5,5)),
                viewPane.getBorder())); */
        
        controlPane = new JPanel();
        controlPane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("Controls"),
                                BorderFactory.createEmptyBorder(5,5,5,5)),
                controlPane.getBorder()));   
        
        controlPane.setLayout(new GridLayout(0,1));
       
        buttonPlus = new JButton("zoom -");
        buttonPlus.setActionCommand("ZOOMIN");
        buttonPlus.addActionListener(this);
        
        buttonMoins = new JButton("zoom +");
        buttonMoins.setActionCommand("ZOOMOUT");
        buttonMoins.addActionListener(this);
        
        buttonCalib = new JButton("Do calibration");
        buttonCalib.setActionCommand("CALIBRATION");
        buttonCalib.addActionListener(this);
        
        historyCheck = new JCheckBox("Show history");
        historyCheck.setSelected(false);
        

        slider3 = new JSlider();
        slider3.setBorder(BorderFactory.createTitledBorder("#node power"));
        slider3.setMinimum(3);
        slider3.setMaximum(31);
        slider3.setSnapToTicks(true);
        slider3.setValue(31);
        slider3.setMajorTickSpacing(4);
        slider3.setPaintTicks(true);
        slider3.setPaintLabels(true);
        
        
        rcvPane.setPreferredSize(new Dimension(150,100));
        rcvPane.setMinimumSize(rcvPane.getPreferredSize());
      
        
        controlPane.add(buttonPlus);
        controlPane.add(buttonMoins);
        controlPane.add(buttonCalib);
        controlPane.add(historyCheck);
        controlPane.add(slider3);
        controlPane.add(rcvPane);

        
        //Create a text area.
        textArea = new JTextArea(
                "Packets arriving on node 0 will be printed here"
        );
        textArea.setEditable(false);
        textArea.setFont(new Font("Serif", Font.ITALIC, 16));
        textArea.setLineWrap(true);
        textArea.setWrapStyleWord(true);
        JScrollPane areaScrollPane = new JScrollPane(textArea);
        areaScrollPane.setVerticalScrollBarPolicy(
                        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        areaScrollPane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                                BorderFactory.createTitledBorder("Output"),
                                BorderFactory.createEmptyBorder(5,5,5,5)),
                areaScrollPane.getBorder()));
        
        areaScrollPane.setPreferredSize(new Dimension(600,200));
        areaScrollPane.setMinimumSize(areaScrollPane.getPreferredSize());  
        


        
        add(controlPane,BorderLayout.EAST);
        add(scroller,BorderLayout.CENTER);
        add(areaScrollPane,BorderLayout.SOUTH);
    }
    
    public void refresh() {
        //here we should call the localisator tell him to refresh
        //
        viewPane.drawingNodes = true;
        viewPane.drawHistory = historyCheck.isSelected();
        
        repaint();
    }
    
    
    public void actionPerformed(ActionEvent e) {
        if ("ZOOMIN".equals(e.getActionCommand())) {
            viewPane.zoomIn();
        } else if ("ZOOMOUT".equals(e.getActionCommand())) {
            viewPane.zoomOut();
        } else if ("CALIBRATION".equals(e.getActionCommand())) {
            CalibrationThread CT = new CalibrationThread();
            CT.setCalibrator(Cal);
            CT.start();
        }
    } 
    
    public void setCalibrator(Calibrator C) {
        Cal=C;
    }
    
    public void setStab(Stabilisator S) {
         viewPane.setStab(S);
    }
    

    
    public void log(String text) {
        try {
            textArea.setText(text.concat("\n").concat(textArea.getText()));
            repaint();
        } catch (Exception e) {
            //do something
            System.out.println("Cannot change textArea text");
        }
    }
}
