package net.tinyos.tools;

import java.io.*;
import net.tinyos.packet.*;
import net.tinyos.util.*;
import net.tinyos.message.*;
import java.awt.*;
import java.util.*;
import java.text.*;

public class MonitorAccel {
    static int nbPacket=0;

    public static double convert(byte b) {
        double res=(double)b;
        if (res<0) res=256+res;
        return res;
    }


    public static void main(String args[]) throws IOException {
        if (args.length != 1) {
            System.err.println("usage: java net.tinyos.tools.Monitor <mode>  | <mode> = 1 -> display <mode>= 2 -> log <mode>= 3 -> both");
            System.exit(2);
        }

		int _mode;
		try {
			_mode = Integer.parseInt(args[0]);
		} catch (NumberFormatException e) {
			System.err.println("<mode> must be 1,2 or 3 using 3 by default");
			_mode = 3;
		}


        DecimalFormat f = new DecimalFormat();
        f.setMaximumFractionDigits(2);

        DecimalFormat fent = new DecimalFormat();
        fent.setMaximumFractionDigits(0);
        fent.setGroupingUsed(false);



        long startMillis = System.currentTimeMillis();
        long dayCurrentN=Math.round(System.currentTimeMillis()/86400000);
        long dayCurrentR=dayCurrentN;

		PrintWriter fileR=null,fileN=null;

		if (_mode==2 || _mode==3)
		{
			fileR=new PrintWriter(new BufferedWriter
						  (new FileWriter("accel" + startMillis+"_"+dayCurrentR+".txt")));

		}

        PacketSource reader = BuildSource.makePacketSource();
        if (reader == null) {
            System.err.println("Invalid packet source (check your MOTECOM environment variable)");
            System.exit(2);
        }
          reader.open(PrintStreamMessenger.err);



          for (;;) {
			try {

				byte[] packet = reader.readPacket();
				//Dump.printPacket(System.out, packet);
				//System.out.println("");

				if (packet.length == 20 && packet[8]==33) {
					//paquet de readings

					double nodeid = convert(packet[10]);

					double seqno = ( (convert(packet[15])*256*256*256) + (convert(packet[14])*256*256) + (convert(packet[13])*256) + (convert(packet[12])) );

					double accelX = convert(packet[17]) * 256 + convert(packet[16]);
					double accelY = convert(packet[19]) * 256 + convert(packet[18]);


					if (_mode == 1 || _mode == 3) {
						System.out.println("READING:*********");
						System.out.println("node id = " + fent.format(nodeid));
						System.out.println("seq no = " + fent.format(seqno));
						System.out.println("accelX = " + f.format(accelX));
						System.out.println("accelY = " + f.format(accelY));
						System.out.println("*****************");
					}

					if (_mode == 2 || _mode == 3) {
						long dayCurrentNewR=Math.round(System.currentTimeMillis()/86400000);

						try {
							if (dayCurrentNewR>dayCurrentR) {
								fileR.close();
								fileR=new PrintWriter(new BufferedWriter
													 (new FileWriter("readings"+startMillis+"_"+dayCurrentNewR+".txt")));

								dayCurrentR=dayCurrentNewR;
							}


							long currentTime=System.currentTimeMillis();
							fileR.println(currentTime +
										 " " + fent.format(nodeid) +
										 " " + fent.format(seqno) +
										 " " + f.format(accelX) +
										 " " + f.format(accelY));
							fileR.flush();

						} catch (IOException exc) {
							System.err.println("Error on fileR : " + exc);
						}
					}
				}

			}
			catch (Exception e) {
			            System.err.println("Error on : " + e + ": " + e.getMessage());
        	}
        }

    }
}
