// $Id: Delta.h 896 2006-08-02 02:17:38Z polastre $
/*
 * Copyright (c) 2006 Moteiv Corporation
 * All rights reserved.
 *
 * This file is distributed under the terms in the attached MOTEIV-LICENSE
 * file. If you do not find these files, copies can be found at
 * http://www.moteiv.com/MOTEIV-LICENSE.txt and by emailing info@moteiv.com.
 */
#ifndef H_Sdrain_h
#define H_Sdrain_h



enum {

//	INTER_MESSAGE_TIME = 256,
	INTER_MESSAGE_TIME = 5120,

	READING_SIZE = 6,

	NEIGHBORS_PER_MSG = 2,

	TXQUEUE_MAX = 100, //max 255
	PINGQUEUE_MAX = 50, //max 255
	NEIGHBORS_MAX = 25, //max 255

//	SENSING_TIMEOUT = 20, //5*4
//	DISCOVERY_TIMEOUT = 100, //25*4
//	TOTAL_TIMEOUT =240, //60*4

	SENSING_TIMEOUT = 5, //5*4
	DISCOVERY_TIMEOUT = 25, //25*4
	TOTAL_TIMEOUT = 60, //60*4


	//sensing states
	START = 60,
	SENSING = 61,
	DONE = 62,

	//discovery states
	//START = 54,
	PING = 55,
	FINISH = 56,

	//Sdrain status
	SEQ_START = 1,
	SENSING_START = 2,
	SENSING_FINISH = 3,
	DISCOVERY_START = 4,
	DISCOVERY_FINISH = 5,
};

enum {
  AM_READINGSMSG = 33,
  AM_NEIGHBORSMSG = 34,
  AM_PINGMSG = 35,
  AM_PONGMSG = 36
};

typedef struct Neighbor {
	uint8_t id;
	uint8_t rssi;
	uint8_t lqi;
} Neighbor;


typedef struct PingMsg {
	uint16_t originAddr;
} PingMsg;

typedef struct PongMsg {
	uint16_t originAddr;
} PongMsg;


typedef struct ReadingsMsg {
  uint32_t seq_no;
	uint16_t readings[READING_SIZE];
} ReadingsMsg;


typedef struct NeighborsMsg {
  uint32_t r_seq_no; //the Corresponding ReadingsMsg seq_no
	uint8_t idx; //the msg number in Neigbors sequence
	uint8_t realNeighborsCount; //the real number of valid neighbors in this msg
  uint8_t neighbors[NEIGHBORS_PER_MSG];
  uint8_t quality[NEIGHBORS_PER_MSG];
	uint8_t strength[NEIGHBORS_PER_MSG];
} NeighborsMsg;

#endif//H_Delta_h

